
' (C) 2007 i-TECH and Kristopher Windsor

#include once "itech\fromweb\multiput.bi"

Const font_size_x = 16, font_size_y = 18, font_center = 10001, ufont_character = 50

Dim Shared As String font_characters
Dim Shared As Uinteger Ptr font_character_graphics(0 To ufont_character), font_background_graphic

Sub font_start (fontfile As String = fb_include_path_data & "font_default.bmp", _font_characters As String = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ[]!?")
  Dim As Integer a, b
  Dim As Uinteger Ptr tempfontimage
  font_characters = _font_characters

  'load font
  tempfontimage = imagecreate(Len(font_characters) * font_size_x, font_size_y)
  Bload fontfile, tempfontimage
  For a = 0 To Len(font_characters) - 1
    font_character_graphics(a) = imagecreate(font_size_x, font_size_y)
    Get tempfontimage, (a * font_size_x, 0) - (a * font_size_x + 15, font_size_y - 1), font_character_graphics(a)
  Next a
  imagedestroy(tempfontimage)

  'create font_background_graphic
  font_background_graphic = imagecreate(font_size_x, font_size_x)

  For a = 0 To 15
    b = Int(Abs(a - 7.5))
    If b <= 5 Then b = 150 Else b = Int(150 - (b - 5) * 50) '85 = 255 / 3
    Line font_background_graphic, (0, a) - (15, a), Rgba(255, 255, 255, b)
  Next a
End Sub

Sub font_display (Byref _text As String, _
                 Byval xplace As Integer, _
                 Byval yplace As Integer, _
                 Byref alphavalue As Integer = 255, _
                 Byref usebackground As Integer = false)

  Dim text As String = _text
  If xplace = font_center Then xplace = (screen_size_x - Len(text) * font_size_x) / 2
  Dim As Integer x = xplace, y = yplace, a, textlength = Len(text)

  text = Ucase(text)
  'debug print text: sleep
  For a = 1 To textlength
    If x + 16 > screen_size_x Then x = 0: y += 20
    If Mid(text, a, 1) = "\" Then
      x = xplace: y += 20
    Else
      If usebackground Then Put (x, y), font_background_graphic, alpha
      If Instr(font_characters, Mid(text, a, 1)) > 0 Then
         Put (x, y), font_character_graphics(Instr(font_characters, Mid(text, a, 1)) - 1), alpha, alphavalue
      End If
      'debug print mid(text, a, 1); x; y: sleep 200
    End If
    x += 16
  Next a
End Sub

Sub font_display_multiput (Byref _text As String, _
                 Byval xplace As Integer, _
                 Byval yplace As Integer, _
                 Byref xscalefactor As Double = 1, _
                 Byref yscalefactor As Double = 1, _
                 Byref rotationangle As Single = 0, _
                 Byref alphavalue As Integer = 255)

  Dim text As String = _text
  Const charactersperline = 80

  'need to calculate graphic size before creating graphic
  Dim As Integer a, textlength = Len(text), maxx = 0, maxy = 1, currentx = 0
  For a = 1 To textlength
    If Mid(text, a, 1) = "\" Then
      currentx = 0: maxy += 1
    Else
      currentx += 1
      If currentx > maxx Then maxx = currentx
      If currentx > charactersperline Then currentx = 0: maxy += 1
    End If
  Next a

  Dim textfield As Uinteger Ptr
  textfield = imagecreate(maxx * font_size_x + 2, maxy * font_size_y + (maxy - 1) * 2 + 2) '+1 fixes bugs

  'write image to buffer
  Dim As Integer x = 1, y = 1
  text = Ucase(text)
  For a = 1 To textlength
    If x / 16! >= charactersperline Then x = 0: y += 20
    If Mid(text, a, 1) = "\" Then
      x = 1: y += 20
    Else
      If Instr(font_characters, Mid(text, a, 1)) > 0 Then
        Put textfield, (x, y), font_character_graphics(Instr(font_characters, Mid(text, a, 1)) - 1), trans
      End If
      'debug put (100 + x, 100), font_character_graphics(instr(font_characters, mid(text, a, 1)) - 1), pset
      x += 16
    End If
  Next a
  'debug screenunlock: put (0, 0), textfield, pset: sleep: screenlock

  'display buffer with multiput
  If xplace = font_center Then xplace = screen_size_x_half
  If yplace = font_center Then yplace = screen_size_y_half
  'yscalefactor offset centers text because bottom two pix are invisible
  MultiPut , xplace, yplace + yscalefactor, textfield, xscalefactor, yscalefactor, rotationangle, true, alphavalue
  imagedestroy(textfield)
End Sub

Sub font_finish
  For a As Integer = 0 To Len(font_characters) - 1
    imagedestroy(font_character_graphics(a))
  Next a
  imagedestroy(font_background_graphic)
End Sub
