
' (C) 2007 i-TECH and Kristopher Windsor

'to test line and circle collision, this program creates a line in the circle, then tests collision with that line
'the line create in the circle has to be perpendicular to the line tested for collision

'color code: green = no collision with circle; blue = collision with circle; red = lines created to test line - circle collision

Type icircle
  As Double x, y, r
  as integer k
End Type

Type iline
  As Double x1, y1, x2, y2
  'a, b, and c are recalculated every frame based on the values of the x and y coords
  As Double a, b, c
  as integer k
End Type

Function line_collision (Byref l1 As lne, Byref l2 As lne, Byref x As Double = 0, Byref y As Double = 0) As Integer
  'accepts x and y so it can use them to return the collision coordinates

  Dim As Integer on1x, on1y, on2x, on2y
  Dim As Double det

  det = l1.a * l2.b - l2.a * l1.b
  If det = 0 Then Return 0 'parallel (maybe an error?)
  'point of collision
  x = (l2.b * l1.c - l1.b * l2.c) / det
  y = (l1.a * l2.c - l2.a * l1.c) / det

  With l1
    If .x1 < .x2 Then
      on1x = (x >= .x1 And x <= .x2)
    Else
      on1x = (x <= .x1 And x >= .x2)
    End If
    If .y1 < .y2 Then
      on1y = (y >= .y1 And y <= .y2)
    Else
      on1y = (y <= .y1 And y >= .y2)
    End If
  End With

  With l2
    If .x1 < .x2 Then
      on2x = (x >= .x1 And x <= .x2)
    Else
      on2x = (x <= .x1 And x >= .x2)
    End If
    If .y1 < .y2 Then
      on2y = (y >= .y1 And y <= .y2)
    Else
      on2y = (y <= .y1 And y >= .y2)
    End If
  End With

  Return on1x And on1y And on2x And on2y
End Function

Function line_collision_circle (Byref l As lne, Byref c As crcle, Byref x As Double, Byref y As Double) As Integer
  'handles two cases: if an endpoint of the line is in the circle, it returns true
  'otherwise, it creates a line in the circle and tests line - line collision

  If ((l.x1 - c.x) * (l.x1 - c.x) + (l.y1 - c.y) * (l.y1 - c.y)) < c.r * c.r Then x = l.x1: y = l.y1: Return -1
  If ((l.x2 - c.x) * (l.x2 - c.x) + (l.y2 - c.y) * (l.y2 - c.y)) < c.r * c.r Then x = l.x2: y = l.y2: Return -1

  Dim As Double d
  Dim As lne cl

  With l
    d = Atan2(-.a, .b) + Atn(1) * 2
  End With

  With cl
    .x1 = c.x - Cos(d) * c.r
    .y1 = c.y - Sin(d) * c.r
    .x2 = c.x + Cos(d) * c.r
    .y2 = c.y + Sin(d) * c.r
    'update a, b, c based on the x and y values (has to be done everytime the x or y values change)
    .a = .y2 - .y1
    .b = .x1 - .x2
    .c = .a * .x1 + .b * .y1
    Line (.x1, .y1) - (.x2, .y2), &HFFFF0000
  End With

  Return line_collision(l, cl, x, y)
End Function
