
' (C) 2007 i-TECH and Kristopher Windsor

Const uparticle = 100

Type particle
  As Double x, y, d
  As Integer c
End Type

Dim Shared As Integer particle_size, particle_color, particle_total
Dim Shared As Double particle_spread, particle_speed
Dim Shared As particle particles(1 To uparticle)

Sub particle_start (Byref size As Integer = 4, Byref spread As Double = pi / 8, Byref speed As Double = 4, Byref c As Integer = &HFF000000)
  particle_size = size
  particle_spread = spread
  particle_speed = speed
  particle_color = c
End Sub

Sub particle_reset
  particle_total = 0
End Sub

Sub particle_add (Byref x As Double, Byref y As Double, Byref c As Integer = particle_color)
  If particle_total = uparticle Then Exit Sub

  particle_total += 1
  With particles(particle_total)
    .x = x
    .y = y
    .d = 0
    .c = c
  End With
End Sub

Sub particle_move
  Dim As Integer a

  a = 1
  While a <= particle_total And particle_total > 0
    If particles(a).d > screen_size_x Then
      Swap particles(a), particles(particle_total)
      particle_total -= 1
    Else
      particles(a).d += particle_speed
      a += 1
    End If
  Wend
End Sub

Sub particle_display
  For a As Integer = 1 To particle_total
    With particles(a)
      For d As Double = 0 To pi_double Step particle_spread
        Circle (.x + Cos(d) * .d, .y + Sin(d) * .d), particle_size, .c
      Next d
    End With
  Next a
End Sub
